package net.wanji.utc.service.systemadmin.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import net.wanji.utc.mapper.CrossInfoMapper;
import net.wanji.utc.mapper.ManufacturerInfoMapper;
import net.wanji.utc.po.CrossInfoPO;
import net.wanji.utc.po.ManufacturerInfoPO;
import net.wanji.utc.service.systemadmin.CrossInfoService;
import net.wanji.utc.util.PageUtils;
import net.wanji.utc.vo.systemadmin.CrossInfoListInVO;
import net.wanji.utc.vo.systemadmin.CrossInfoListOutVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Kent HAN
 * @date 2022/11/25 8:54
 */
@Service
public class CrossInfoServiceImpl implements CrossInfoService {
    @Autowired
    ManufacturerInfoMapper manufacturerInfoMapper;
    @Autowired
    CrossInfoMapper crossInfoMapper;

    @Override
    public PageInfo<CrossInfoListOutVO> list(CrossInfoListInVO crossInfoListInVO) {
        Integer pageNum = crossInfoListInVO.getPageNum();
        Integer pageSize = crossInfoListInVO.getPageSize();

        String crossName = crossInfoListInVO.getCrossName();

        String manufacturerNick = crossInfoListInVO.getManufacturerName();
        Integer manufacturerId = null;
        if (manufacturerNick != null) {
            manufacturerId = manufacturerInfoMapper.selectIdByNick(manufacturerNick);
        }

        PageHelper.startPage(pageNum, pageSize);
        List<CrossInfoPO> crossInfoPOList = crossInfoMapper.selectByOptionals(crossName, manufacturerId);
        PageInfo<CrossInfoPO> crossInfoPOPageInfo = new PageInfo<>(crossInfoPOList);
        // 转换为VO类型的PageInfo对象
        PageInfo<CrossInfoListOutVO> crossInfoListOutVOPageInfo = PageUtils.PageInfo2PageInfoVo(crossInfoPOPageInfo);
        for (CrossInfoPO crossInfoPO : crossInfoPOList) {
            CrossInfoListOutVO crossInfoListOutVO = new CrossInfoListOutVO();
            BeanUtils.copyProperties(crossInfoPO, crossInfoListOutVO);
            Integer manufacturerIdInPage = crossInfoPO.getManufacturerId();
            ManufacturerInfoPO manufacturerInfoPO = manufacturerInfoMapper.selectById(manufacturerIdInPage);
            String nickName = manufacturerInfoPO.getNickName();
            crossInfoListOutVO.setManufacturerNick(nickName);
            crossInfoListOutVOPageInfo.getList().add(crossInfoListOutVO);
        }

        return crossInfoListOutVOPageInfo;
    }
}
